/*!
 * @package      YJ Reservations
 * @copyright    Copyright(C) since 2007  Youjoomla.com. All Rights Reserved.
 * @author       YouJoomla
 * @license      http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 * @websites     http://www.youjoomla.com | http://www.yjsimplegrid.com
 */
(function($) {

    $.fn.YjReservations = function( options ) {

       
        var settings = $.extend({
            base         	: null,
			form	 	 	: this,
			parent		 	: this.parent(),
			dateformat		: 'mmmm-dd-yyyy',
			interval		: 30,
			timemin			: [9,30],
			timemax			: [22,30],
			tipscroll		: false,
			timeformat		: 'h:i A'
        }, options);


		function beforeAjax(form, options) {
			$(settings.parent).find('.res-form-group-progress-bar').animate({
				width: "100%"
			}, 500);
			return true;
		}

		function afterAjax(status, form, json, options) {
		
		
			if (status === true) {
				$(settings.form)[0].reset();
				$(settings.form).validationEngine('showPrompt', json.success, 'load', 'topLeft');
		
				$(settings.parent).find('.res-form-group-progress-bar').animate({
					width: "0px"
				}, 200);
		
		
			} else {
		
				$(settings.form).validationEngine('showPrompt', json.error, 'load', 'topLeft');
			}
		}

        return this.each( function() {

			$(this).validationEngine({
				scroll: settings.tipscroll,
				ajaxFormValidation: true,
				ajaxFormValidationMethod: 'post',
				onBeforeAjaxFormValidation: beforeAjax,
				onAjaxFormComplete: afterAjax,
				autoPositionUpdate: true,
				autoHidePrompt: true,
				autoHideDelay: 3000,
				fadeDuration: 0.3,
				ajaxFormValidationURL: settings.base + 'modules/mod_yj_reservations/libs/ajax_validate.php'
			});			
			
			$(settings.parent).find('.res_date').pickadate({
		
				format: settings.dateformat
		
			});
		
			$(settings.parent).find('.res_time').pickatime({
				
				format: settings.timeformat,
				interval:settings.interval,
				min: settings.timemin,
				max: settings.timemax
			});			
           
        });

    }

}(jQuery));


/*!
 * Inline Form Validation Engine 2.6.2, jQuery plugin
 *
 * Copyright(c) 2010, Cedric Dugas
 * http://www.position-absolute.com
 *
 * 2.0 Rewrite by Olivier Refalo
 * http://www.crionics.com
 *
 * Form validation engine allowing custom regex rules to be added.
 * Licensed under the MIT License
 */

!function(e){"use strict";var a={init:function(t){var r=this;return r.data("jqv")&&null!=r.data("jqv")||(t=a._saveOptions(r,t),e(document).on("click",".formError",function(){e(this).fadeOut(150,function(){e(this).closest(".formError").remove()})})),this},attach:function(t){var r,i=this;return r=t?a._saveOptions(i,t):i.data("jqv"),r.validateAttribute=i.find("[data-validation-engine*=validate]").length?"data-validation-engine":"class",r.binded&&(i.on(r.validationEventTrigger,"["+r.validateAttribute+"*=validate]:not([type=checkbox]):not([type=radio]):not(.datepicker)",a._onFieldEvent),i.on("click","["+r.validateAttribute+"*=validate][type=checkbox],["+r.validateAttribute+"*=validate][type=radio]",a._onFieldEvent),i.on(r.validationEventTrigger,"["+r.validateAttribute+"*=validate][class*=datepicker]",{delay:300},a._onFieldEvent)),r.autoPositionUpdate&&e(window).bind("resize",{noAnimation:!0,formElem:i},a.updatePromptsPosition),i.on("click","a[data-validation-engine-skip], a[class*='validate-skip'], button[data-validation-engine-skip], button[class*='validate-skip'], input[data-validation-engine-skip], input[class*='validate-skip']",a._submitButtonClick),i.removeData("jqv_submitButton"),i.on("submit",a._onSubmitEvent),this},detach:function(){var t=this,r=t.data("jqv");return t.off(r.validationEventTrigger,"["+r.validateAttribute+"*=validate]:not([type=checkbox]):not([type=radio]):not(.datepicker)",a._onFieldEvent),t.off("click","["+r.validateAttribute+"*=validate][type=checkbox],["+r.validateAttribute+"*=validate][type=radio]",a._onFieldEvent),t.off(r.validationEventTrigger,"["+r.validateAttribute+"*=validate][class*=datepicker]",a._onFieldEvent),t.off("submit",a._onSubmitEvent),t.removeData("jqv"),t.off("click","a[data-validation-engine-skip], a[class*='validate-skip'], button[data-validation-engine-skip], button[class*='validate-skip'], input[data-validation-engine-skip], input[class*='validate-skip']",a._submitButtonClick),t.removeData("jqv_submitButton"),r.autoPositionUpdate&&e(window).off("resize",a.updatePromptsPosition),this},validate:function(t){var r,i=e(this),o=null;if(i.is("form")||i.hasClass("validationEngineContainer")){if(i.hasClass("validating"))return!1;i.addClass("validating"),r=t?a._saveOptions(i,t):i.data("jqv");var o=a._validateFields(this);setTimeout(function(){i.removeClass("validating")},100),o&&r.onSuccess?r.onSuccess():!o&&r.onFailure&&r.onFailure()}else if(i.is("form")||i.hasClass("validationEngineContainer"))i.removeClass("validating");else var s=i.closest("form, .validationEngineContainer"),r=s.data("jqv")?s.data("jqv"):e.validationEngine.defaults,o=a._validateField(i,r);return r.onValidationComplete?!!r.onValidationComplete(s,o):o},updatePromptsPosition:function(t){if(t&&this==window)var r=t.data.formElem,i=t.data.noAnimation;else var r=e(this.closest("form, .validationEngineContainer"));var o=r.data("jqv");return o||(o=a._saveOptions(r,o)),r.find("["+o.validateAttribute+"*=validate]").not(":disabled").each(function(){var t=e(this);o.prettySelect&&t.is(":hidden")&&(t=r.find("#"+o.usePrefix+t.attr("id")+o.useSuffix));var s=a._getPrompt(t),n=e(s).find(".formErrorContent").html();s&&a._updatePrompt(t,e(s),n,void 0,!1,o,i)}),this},showPrompt:function(e,t,r,i){var o=this.closest("form, .validationEngineContainer"),s=o.data("jqv");return s||(s=a._saveOptions(this,s)),r&&(s.promptPosition=r),s.showArrow=1==i,a._showPrompt(this,e,t,!1,s),this},hide:function(){var t=e(this).closest("form, .validationEngineContainer"),r=t.data("jqv");r||(r=a._saveOptions(t,r));var i,o=r&&r.fadeDuration?r.fadeDuration:.3;return i=e(this).is("form")||e(this).hasClass("validationEngineContainer")?"parentForm"+a._getClassName(e(this).attr("id")):a._getClassName(e(this).attr("id"))+"formError",e("."+i).fadeTo(o,0,function(){e(this).closest(".formError").remove()}),this},hideAll:function(){var a=this,t=a.data("jqv"),r=t?t.fadeDuration:300;return e(".formError").fadeTo(r,0,function(){e(this).closest(".formError").remove()}),this},_onFieldEvent:function(t){var r=e(this),i=r.closest("form, .validationEngineContainer"),o=i.data("jqv");o||(o=a._saveOptions(i,o)),o.eventTrigger="field",1==o.notEmpty?r.val().length>0&&window.setTimeout(function(){a._validateField(r,o)},t.data?t.data.delay:0):window.setTimeout(function(){a._validateField(r,o)},t.data?t.data.delay:0)},_onSubmitEvent:function(){var t=e(this),r=t.data("jqv");if(t.data("jqv_submitButton")){var i=e("#"+t.data("jqv_submitButton"));if(i&&i.length>0&&(i.hasClass("validate-skip")||"true"==i.attr("data-validation-engine-skip")))return!0}r.eventTrigger="submit";var o=a._validateFields(t);return o&&r.ajaxFormValidation?(a._validateFormWithAjax(t,r),!1):r.onValidationComplete?!!r.onValidationComplete(t,o):o},_checkAjaxStatus:function(a){var t=!0;return e.each(a.ajaxValidCache,function(e,a){return a?void 0:(t=!1,!1)}),t},_checkAjaxFieldStatus:function(e,a){return 1==a.ajaxValidCache[e]},_validateFields:function(t){var r=t.data("jqv"),i=!1;t.trigger("jqv.form.validating");var o=null;if(t.find("["+r.validateAttribute+"*=validate]").not(":disabled").each(function(){var s=e(this),n=[];if(e.inArray(s.attr("name"),n)<0){if(i|=a._validateField(s,r),i&&null==o&&(s.is(":hidden")&&r.prettySelect?o=s=t.find("#"+r.usePrefix+a._jqSelector(s.attr("id"))+r.useSuffix):(s.data("jqv-prompt-at")instanceof jQuery?s=s.data("jqv-prompt-at"):s.data("jqv-prompt-at")&&(s=e(s.data("jqv-prompt-at"))),o=s)),r.doNotShowAllErrosOnSubmit)return!1;if(n.push(s.attr("name")),1==r.showOneMessage&&i)return!1}}),t.trigger("jqv.form.result",[i]),i){if(r.scroll){var s=o.offset().top,n=o.offset().left,l=r.promptPosition;if("string"==typeof l&&-1!=l.indexOf(":")&&(l=l.substring(0,l.indexOf(":"))),"bottomRight"!=l&&"bottomLeft"!=l){var d=a._getPrompt(o);d&&(s=d.offset().top)}if(r.scrollOffset&&(s-=r.scrollOffset),r.isOverflown){var u=e(r.overflownDIV);if(!u.length)return!1;var c=u.scrollTop(),f=-parseInt(u.offset().top);s+=c+f-5;var v=e(r.overflownDIV).filter(":not(:animated)");v.animate({scrollTop:s},1100,function(){r.focusFirstField&&o.focus()})}else e("html, body").animate({scrollTop:s},1100,function(){r.focusFirstField&&o.focus()}),e("html, body").animate({scrollLeft:n},1100)}else r.focusFirstField&&o.focus();return!1}return!0},_validateFormWithAjax:function(t,r){var i=t.serialize(),o=r.ajaxFormValidationMethod?r.ajaxFormValidationMethod:"GET",s=r.ajaxFormValidationURL?r.ajaxFormValidationURL:t.attr("action"),n=r.dataType?r.dataType:"json";e.ajax({type:o,url:s,cache:!1,dataType:n,data:i,form:t,methods:a,options:r,beforeSend:function(){return r.onBeforeAjaxFormValidation(t,r)},error:function(e,t){r.onFailure?r.onFailure(e,t):a._ajaxError(e,t)},success:function(i){if("json"==n&&i!==!0){for(var o=!1,s=0;s<i.length;s++){var l=i[s],d=l[0],u=e(e("#"+d)[0]);if(1==u.length){var c=l[2];if(1==l[1])if(""!=c&&c){if(r.allrules[c]){var f=r.allrules[c].alertTextOk;f&&(c=f)}r.showPrompts&&a._showPrompt(u,c,"pass",!1,r,!0)}else a._closePrompt(u);else{if(o|=!0,r.allrules[c]){var f=r.allrules[c].alertText;f&&(c=f)}r.showPrompts&&a._showPrompt(u,c,"",!1,r,!0)}}}r.onAjaxFormComplete(!o,t,i,r)}else r.onAjaxFormComplete(!0,t,i,r)}})},_validateField:function(t,r,i){if(t.attr("id")||(t.attr("id","form-validation-field-"+e.validationEngine.fieldIdCounter),++e.validationEngine.fieldIdCounter),t.hasClass(r.ignoreFieldsWithClass))return!1;if(!r.validateNonVisibleFields&&(t.is(":hidden")&&!r.prettySelect||t.parent().is(":hidden")))return!1;var o=t.attr(r.validateAttribute),s=/validate\[(.*)\]/.exec(o);if(!s)return!1;var n=s[1],l=n.split(/\[|,|\]/),d=!1,u=t.attr("name"),c="",f="",v=!1,p=!1;r.isError=!1,r.showArrow=!0,r.maxErrorsPerField>0&&(p=!0);for(var m=e(t.closest("form, .validationEngineContainer")),g=0;g<l.length;g++)l[g]=l[g].replace(" ",""),""===l[g]&&delete l[g];for(var g=0,h=0;g<l.length;g++){if(p&&h>=r.maxErrorsPerField){if(!v){var _=e.inArray("required",l);v=-1!=_&&_>=g}break}var x=void 0;switch(l[g]){case"required":v=!0,x=a._getErrorMessage(m,t,l[g],l,g,r,a._required);break;case"custom":x=a._getErrorMessage(m,t,l[g],l,g,r,a._custom);break;case"groupRequired":var C="["+r.validateAttribute+"*="+l[g+1]+"]",b=m.find(C).eq(0);b[0]!=t[0]&&(a._validateField(b,r,i),r.showArrow=!0),x=a._getErrorMessage(m,t,l[g],l,g,r,a._groupRequired),x&&(v=!0),r.showArrow=!1;break;case"ajax":x=a._ajax(t,l,g,r),x&&(f="load");break;case"minSize":x=a._getErrorMessage(m,t,l[g],l,g,r,a._minSize);break;case"maxSize":x=a._getErrorMessage(m,t,l[g],l,g,r,a._maxSize);break;case"min":x=a._getErrorMessage(m,t,l[g],l,g,r,a._min);break;case"max":x=a._getErrorMessage(m,t,l[g],l,g,r,a._max);break;case"past":x=a._getErrorMessage(m,t,l[g],l,g,r,a._past);break;case"future":x=a._getErrorMessage(m,t,l[g],l,g,r,a._future);break;case"dateRange":var C="["+r.validateAttribute+"*="+l[g+1]+"]";r.firstOfGroup=m.find(C).eq(0),r.secondOfGroup=m.find(C).eq(1),(r.firstOfGroup[0].value||r.secondOfGroup[0].value)&&(x=a._getErrorMessage(m,t,l[g],l,g,r,a._dateRange)),x&&(v=!0),r.showArrow=!1;break;case"dateTimeRange":var C="["+r.validateAttribute+"*="+l[g+1]+"]";r.firstOfGroup=m.find(C).eq(0),r.secondOfGroup=m.find(C).eq(1),(r.firstOfGroup[0].value||r.secondOfGroup[0].value)&&(x=a._getErrorMessage(m,t,l[g],l,g,r,a._dateTimeRange)),x&&(v=!0),r.showArrow=!1;break;case"maxCheckbox":t=e(m.find("input[name='"+u+"']")),x=a._getErrorMessage(m,t,l[g],l,g,r,a._maxCheckbox);break;case"minCheckbox":t=e(m.find("input[name='"+u+"']")),x=a._getErrorMessage(m,t,l[g],l,g,r,a._minCheckbox);break;case"equals":x=a._getErrorMessage(m,t,l[g],l,g,r,a._equals);break;case"funcCall":x=a._getErrorMessage(m,t,l[g],l,g,r,a._funcCall);break;case"creditCard":x=a._getErrorMessage(m,t,l[g],l,g,r,a._creditCard);break;case"condRequired":x=a._getErrorMessage(m,t,l[g],l,g,r,a._condRequired),void 0!==x&&(v=!0);break;case"funcCallRequired":x=a._getErrorMessage(m,t,l[g],l,g,r,a._funcCallRequired),void 0!==x&&(v=!0)}var E=!1;if("object"==typeof x)switch(x.status){case"_break":E=!0;break;case"_error":x=x.message;break;case"_error_no_prompt":return!0}if(0==g&&0==n.indexOf("funcCallRequired")&&void 0!==x&&(c+=x+"<br/>",r.isError=!0,h++,E=!0),E)break;"string"==typeof x&&(c+=x+"<br/>",r.isError=!0,h++)}!v&&!t.val()&&t.val().length<1&&e.inArray("equals",l)<0&&(r.isError=!1);var T=t.prop("type"),k=t.data("promptPosition")||r.promptPosition;("radio"==T||"checkbox"==T)&&m.find("input[name='"+u+"']").size()>1&&(t=e("inline"===k?m.find("input[name='"+u+"'][type!=hidden]:last"):m.find("input[name='"+u+"'][type!=hidden]:first")),r.showArrow=r.showArrowOnRadioAndCheckbox),t.is(":hidden")&&r.prettySelect&&(t=m.find("#"+r.usePrefix+a._jqSelector(t.attr("id"))+r.useSuffix)),r.isError&&r.showPrompts?a._showPrompt(t,c,f,!1,r):d||a._closePrompt(t),d||t.trigger("jqv.field.result",[t,r.isError,c]);var w=e.inArray(t[0],r.InvalidFields);return-1==w?r.isError&&r.InvalidFields.push(t[0]):r.isError||r.InvalidFields.splice(w,1),a._handleStatusCssClasses(t,r),r.isError&&r.onFieldFailure&&r.onFieldFailure(t),!r.isError&&r.onFieldSuccess&&r.onFieldSuccess(t),r.isError},_handleStatusCssClasses:function(e,a){a.addSuccessCssClassToField&&e.removeClass(a.addSuccessCssClassToField),a.addFailureCssClassToField&&e.removeClass(a.addFailureCssClassToField),a.addSuccessCssClassToField&&!a.isError&&e.addClass(a.addSuccessCssClassToField),a.addFailureCssClassToField&&a.isError&&e.addClass(a.addFailureCssClassToField)},_getErrorMessage:function(t,r,i,o,s,n,l){var d=jQuery.inArray(i,o);if("custom"===i||"funcCall"===i||"funcCallRequired"===i){var u=o[d+1];i=i+"["+u+"]",delete o[d]}var c,f=i,v=r.attr(r.attr("data-validation-engine")?"data-validation-engine":"class"),p=v.split(" ");if(c="future"==i||"past"==i||"maxCheckbox"==i||"minCheckbox"==i?l(t,r,o,s,n):l(r,o,s,n),void 0!=c){var m=a._getCustomErrorMessage(e(r),p,f,n);m&&(c=m)}return c},_getCustomErrorMessage:function(e,t,r,i){var o=!1,s=/^custom\[.*\]$/.test(r)?a._validityProp.custom:a._validityProp[r];if(void 0!=s&&(o=e.attr("data-errormessage-"+s),void 0!=o))return o;if(o=e.attr("data-errormessage"),void 0!=o)return o;var n="#"+e.attr("id");if("undefined"!=typeof i.custom_error_messages[n]&&"undefined"!=typeof i.custom_error_messages[n][r])o=i.custom_error_messages[n][r].message;else if(t.length>0)for(var l=0;l<t.length&&t.length>0;l++){var d="."+t[l];if("undefined"!=typeof i.custom_error_messages[d]&&"undefined"!=typeof i.custom_error_messages[d][r]){o=i.custom_error_messages[d][r].message;break}}return o||"undefined"==typeof i.custom_error_messages[r]||"undefined"==typeof i.custom_error_messages[r].message||(o=i.custom_error_messages[r].message),o},_validityProp:{required:"value-missing",custom:"custom-error",groupRequired:"value-missing",ajax:"custom-error",minSize:"range-underflow",maxSize:"range-overflow",min:"range-underflow",max:"range-overflow",past:"type-mismatch",future:"type-mismatch",dateRange:"type-mismatch",dateTimeRange:"type-mismatch",maxCheckbox:"range-overflow",minCheckbox:"range-underflow",equals:"pattern-mismatch",funcCall:"custom-error",funcCallRequired:"custom-error",creditCard:"pattern-mismatch",condRequired:"value-missing"},_required:function(a,t,r,i,o){switch(a.prop("type")){case"radio":case"checkbox":if(o){if(!a.prop("checked"))return i.allrules[t[r]].alertTextCheckboxMultiple;break}var s=a.closest("form, .validationEngineContainer"),n=a.attr("name");if(0==s.find("input[name='"+n+"']:checked").size())return 1==s.find("input[name='"+n+"']:visible").size()?i.allrules[t[r]].alertTextCheckboxe:i.allrules[t[r]].alertTextCheckboxMultiple;break;case"text":case"password":case"textarea":case"file":case"select-one":case"select-multiple":default:var l=e.trim(a.val()),d=e.trim(a.attr("data-validation-placeholder")),u=e.trim(a.attr("placeholder"));if(!l||d&&l==d||u&&l==u)return i.allrules[t[r]].alertText}},_groupRequired:function(t,r,i,o){var s="["+o.validateAttribute+"*="+r[i+1]+"]",n=!1;return t.closest("form, .validationEngineContainer").find(s).each(function(){return a._required(e(this),r,i,o)?void 0:(n=!0,!1)}),n?void 0:o.allrules[r[i]].alertText},_custom:function(e,a,t,r){var i,o=a[t+1],s=r.allrules[o];if(!s)return void alert("jqv:custom rule not found - "+o);if(s.regex){var n=s.regex;if(!n)return void alert("jqv:custom regex not found - "+o);var l=new RegExp(n);if(!l.test(e.val()))return r.allrules[o].alertText}else{if(!s.func)return void alert("jqv:custom type not allowed "+o);if(i=s.func,"function"!=typeof i)return void alert("jqv:custom parameter 'function' is no function - "+o);if(!i(e,a,t,r))return r.allrules[o].alertText}},_funcCall:function(e,a,t,r){var i,o=a[t+1];if(o.indexOf(".")>-1){for(var s=o.split("."),n=window;s.length;)n=n[s.shift()];i=n}else i=window[o]||r.customFunctions[o];return"function"==typeof i?i(e,a,t,r):void 0},_funcCallRequired:function(e,t,r,i){return a._funcCall(e,t,r,i)},_equals:function(a,t,r,i){var o=t[r+1];return a.val()!=e("#"+o).val()?i.allrules.equals.alertText:void 0},_maxSize:function(e,a,t,r){var i=a[t+1],o=e.val().length;if(o>i){var s=r.allrules.maxSize;return s.alertText+i+s.alertText2}},_minSize:function(e,a,t,r){var i=a[t+1],o=e.val().length;if(i>o){var s=r.allrules.minSize;return s.alertText+i+s.alertText2}},_min:function(e,a,t,r){var i=parseFloat(a[t+1]),o=parseFloat(e.val());if(i>o){var s=r.allrules.min;return s.alertText2?s.alertText+i+s.alertText2:s.alertText+i}},_max:function(e,a,t,r){var i=parseFloat(a[t+1]),o=parseFloat(e.val());if(o>i){var s=r.allrules.max;return s.alertText2?s.alertText+i+s.alertText2:s.alertText+i}},_past:function(t,r,i,o,s){var n,l=i[o+1],d=e(t.find("*[name='"+l.replace(/^#+/,"")+"']"));if("now"==l.toLowerCase())n=new Date;else if(void 0!=d.val()){if(d.is(":disabled"))return;n=a._parseDate(d.val())}else n=a._parseDate(l);var u=a._parseDate(r.val());if(u>n){var c=s.allrules.past;return c.alertText2?c.alertText+a._dateToString(n)+c.alertText2:c.alertText+a._dateToString(n)}},_future:function(t,r,i,o,s){var n,l=i[o+1],d=e(t.find("*[name='"+l.replace(/^#+/,"")+"']"));if("now"==l.toLowerCase())n=new Date;else if(void 0!=d.val()){if(d.is(":disabled"))return;n=a._parseDate(d.val())}else n=a._parseDate(l);var u=a._parseDate(r.val());if(n>u){var c=s.allrules.future;return c.alertText2?c.alertText+a._dateToString(n)+c.alertText2:c.alertText+a._dateToString(n)}},_isDate:function(e){var a=new RegExp(/^\d{4}[\/\-](0?[1-9]|1[012])[\/\-](0?[1-9]|[12][0-9]|3[01])$|^(?:(?:(?:0?[13578]|1[02])(\/|-)31)|(?:(?:0?[1,3-9]|1[0-2])(\/|-)(?:29|30)))(\/|-)(?:[1-9]\d\d\d|\d[1-9]\d\d|\d\d[1-9]\d|\d\d\d[1-9])$|^(?:(?:0?[1-9]|1[0-2])(\/|-)(?:0?[1-9]|1\d|2[0-8]))(\/|-)(?:[1-9]\d\d\d|\d[1-9]\d\d|\d\d[1-9]\d|\d\d\d[1-9])$|^(0?2(\/|-)29)(\/|-)(?:(?:0[48]00|[13579][26]00|[2468][048]00)|(?:\d\d)?(?:0[48]|[2468][048]|[13579][26]))$/);return a.test(e)},_isDateTime:function(e){var a=new RegExp(/^\d{4}[\/\-](0?[1-9]|1[012])[\/\-](0?[1-9]|[12][0-9]|3[01])\s+(1[012]|0?[1-9]){1}:(0?[1-5]|[0-6][0-9]){1}:(0?[0-6]|[0-6][0-9]){1}\s+(am|pm|AM|PM){1}$|^(?:(?:(?:0?[13578]|1[02])(\/|-)31)|(?:(?:0?[1,3-9]|1[0-2])(\/|-)(?:29|30)))(\/|-)(?:[1-9]\d\d\d|\d[1-9]\d\d|\d\d[1-9]\d|\d\d\d[1-9])$|^((1[012]|0?[1-9]){1}\/(0?[1-9]|[12][0-9]|3[01]){1}\/\d{2,4}\s+(1[012]|0?[1-9]){1}:(0?[1-5]|[0-6][0-9]){1}:(0?[0-6]|[0-6][0-9]){1}\s+(am|pm|AM|PM){1})$/);return a.test(e)},_dateCompare:function(e,a){return new Date(e.toString())<new Date(a.toString())},_dateRange:function(e,t,r,i){return!i.firstOfGroup[0].value&&i.secondOfGroup[0].value||i.firstOfGroup[0].value&&!i.secondOfGroup[0].value?i.allrules[t[r]].alertText+i.allrules[t[r]].alertText2:a._isDate(i.firstOfGroup[0].value)&&a._isDate(i.secondOfGroup[0].value)&&a._dateCompare(i.firstOfGroup[0].value,i.secondOfGroup[0].value)?void 0:i.allrules[t[r]].alertText+i.allrules[t[r]].alertText2},_dateTimeRange:function(e,t,r,i){return!i.firstOfGroup[0].value&&i.secondOfGroup[0].value||i.firstOfGroup[0].value&&!i.secondOfGroup[0].value?i.allrules[t[r]].alertText+i.allrules[t[r]].alertText2:a._isDateTime(i.firstOfGroup[0].value)&&a._isDateTime(i.secondOfGroup[0].value)&&a._dateCompare(i.firstOfGroup[0].value,i.secondOfGroup[0].value)?void 0:i.allrules[t[r]].alertText+i.allrules[t[r]].alertText2},_maxCheckbox:function(e,a,t,r,i){var o=t[r+1],s=a.attr("name"),n=e.find("input[name='"+s+"']:checked").size();return n>o?(i.showArrow=!1,i.allrules.maxCheckbox.alertText2?i.allrules.maxCheckbox.alertText+" "+o+" "+i.allrules.maxCheckbox.alertText2:i.allrules.maxCheckbox.alertText):void 0},_minCheckbox:function(e,a,t,r,i){var o=t[r+1],s=a.attr("name"),n=e.find("input[name='"+s+"']:checked").size();return o>n?(i.showArrow=!1,i.allrules.minCheckbox.alertText+" "+o+" "+i.allrules.minCheckbox.alertText2):void 0},_creditCard:function(e,a,t,r){var i=!1,o=e.val().replace(/ +/g,"").replace(/-+/g,""),s=o.length;if(s>=14&&16>=s&&parseInt(o)>0){var n,l=0,t=s-1,d=1,u=new String;do n=parseInt(o.charAt(t)),u+=d++%2==0?2*n:n;while(--t>=0);for(t=0;t<u.length;t++)l+=parseInt(u.charAt(t));i=l%10==0}return i?void 0:r.allrules.creditCard.alertText},_ajax:function(t,r,i,o){var s=r[i+1],n=o.allrules[s],l=n.extraData,d=n.extraDataDynamic,u={fieldId:t.attr("id"),fieldValue:t.val()};if("object"==typeof l)e.extend(u,l);else if("string"==typeof l)for(var c=l.split("&"),i=0;i<c.length;i++){var f=c[i].split("=");f[0]&&f[0]&&(u[f[0]]=f[1])}if(d)for(var v=String(d).split(","),i=0;i<v.length;i++){var p=v[i];if(e(p).length){{var m=t.closest("form, .validationEngineContainer").find(p).val();p.replace("#","")+"="+escape(m)}u[p.replace("#","")]=m}}return"field"==o.eventTrigger&&delete o.ajaxValidCache[t.attr("id")],o.isError||a._checkAjaxFieldStatus(t.attr("id"),o)?void 0:(e.ajax({type:o.ajaxFormValidationMethod,url:n.url,cache:!1,dataType:"json",data:u,field:t,rule:n,methods:a,options:o,beforeSend:function(){},error:function(e,t){o.onFailure?o.onFailure(e,t):a._ajaxError(e,t)},success:function(r){var i=r[0],s=e("#"+i).eq(0);if(1==s.length){var l=r[1],d=r[2];if(l){if(o.ajaxValidCache[i]=!0,d){if(o.allrules[d]){var u=o.allrules[d].alertTextOk;u&&(d=u)}}else d=n.alertTextOk;o.showPrompts&&(d?a._showPrompt(s,d,"pass",!0,o):a._closePrompt(s)),"submit"==o.eventTrigger&&t.closest("form").submit()}else{if(o.ajaxValidCache[i]=!1,o.isError=!0,d){if(o.allrules[d]){var u=o.allrules[d].alertText;u&&(d=u)}}else d=n.alertText;o.showPrompts&&a._showPrompt(s,d,"",!0,o)}}s.trigger("jqv.field.result",[s,o.isError,d])}}),n.alertTextLoad)},_ajaxError:function(e,a){0==e.status&&null==a?alert("The page is not served from a server! ajax call failed"):"undefined"!=typeof console&&console.log("Ajax error: "+e.status+" "+a)},_dateToString:function(e){return e.getFullYear()+"-"+(e.getMonth()+1)+"-"+e.getDate()},_parseDate:function(e){var a=e.split("-");return a==e&&(a=e.split("/")),a==e?(a=e.split("."),new Date(a[2],a[1]-1,a[0])):new Date(a[0],a[1]-1,a[2])},_showPrompt:function(t,r,i,o,s,n){t.data("jqv-prompt-at")instanceof jQuery?t=t.data("jqv-prompt-at"):t.data("jqv-prompt-at")&&(t=e(t.data("jqv-prompt-at")));var l=a._getPrompt(t);n&&(l=!1),e.trim(r)&&(l?a._updatePrompt(t,l,r,i,o,s):a._buildPrompt(t,r,i,o,s))},_buildPrompt:function(t,r,i,o,s){var n=e("<div>");switch(n.addClass(a._getClassName(t.attr("id"))+"formError"),n.addClass("parentForm"+a._getClassName(t.closest("form, .validationEngineContainer").attr("id"))),n.addClass("formError"),i){case"pass":n.addClass("greenPopup");break;case"load":n.addClass("blackPopup")}o&&n.addClass("ajaxed");var l=(e("<div>").addClass("formErrorContent").html(r).appendTo(n),t.data("promptPosition")||s.promptPosition);if(s.showArrow){var d=e("<div>").addClass("formErrorArrow");if("string"==typeof l){var u=l.indexOf(":");-1!=u&&(l=l.substring(0,u))}switch(l){case"bottomLeft":case"bottomRight":n.find(".formErrorContent").before(d),d.addClass("formErrorArrowBottom").html('<div class="line1"><!-- --></div><div class="line2"><!-- --></div><div class="line3"><!-- --></div><div class="line4"><!-- --></div><div class="line5"><!-- --></div><div class="line6"><!-- --></div><div class="line7"><!-- --></div><div class="line8"><!-- --></div><div class="line9"><!-- --></div><div class="line10"><!-- --></div>');break;case"topLeft":case"topRight":d.html('<div class="line10"><!-- --></div><div class="line9"><!-- --></div><div class="line8"><!-- --></div><div class="line7"><!-- --></div><div class="line6"><!-- --></div><div class="line5"><!-- --></div><div class="line4"><!-- --></div><div class="line3"><!-- --></div><div class="line2"><!-- --></div><div class="line1"><!-- --></div>'),n.append(d)}}s.addPromptClass&&n.addClass(s.addPromptClass);var c=t.attr("data-required-class");if(void 0!==c)n.addClass(c);else if(s.prettySelect&&e("#"+t.attr("id")).next().is("select")){var f=e("#"+t.attr("id").substr(s.usePrefix.length).substring(s.useSuffix.length)).attr("data-required-class");void 0!==f&&n.addClass(f)}n.css({opacity:0}),"inline"===l?(n.addClass("inline"),"undefined"!=typeof t.attr("data-prompt-target")&&e("#"+t.attr("data-prompt-target")).length>0?n.appendTo(e("#"+t.attr("data-prompt-target"))):t.after(n)):t.before(n);var u=a._calculatePosition(t,n,s);return n.css({position:"inline"===l?"relative":"absolute",top:u.callerTopPosition,left:u.callerleftPosition,marginTop:u.marginTopSize,opacity:0}).data("callerField",t),s.autoHidePrompt&&setTimeout(function(){n.animate({opacity:0},function(){n.closest(".formError").remove()})},s.autoHideDelay),n.animate({opacity:.87})},_updatePrompt:function(e,t,r,i,o,s,n){if(t){"undefined"!=typeof i&&("pass"==i?t.addClass("greenPopup"):t.removeClass("greenPopup"),"load"==i?t.addClass("blackPopup"):t.removeClass("blackPopup")),o?t.addClass("ajaxed"):t.removeClass("ajaxed"),t.find(".formErrorContent").html(r);var l=a._calculatePosition(e,t,s),d={top:l.callerTopPosition,left:l.callerleftPosition,marginTop:l.marginTopSize,opacity:.87};n?t.css(d):t.animate(d)}},_closePrompt:function(e){var t=a._getPrompt(e);t&&t.fadeTo("fast",0,function(){t.closest(".formError").remove()})},closePrompt:function(e){return a._closePrompt(e)},_getPrompt:function(t){var r=e(t).closest("form, .validationEngineContainer").attr("id"),i=a._getClassName(t.attr("id"))+"formError",o=e("."+a._escapeExpression(i)+".parentForm"+a._getClassName(r))[0];return o?e(o):void 0},_escapeExpression:function(e){return e.replace(/([#;&,\.\+\*\~':"\!\^$\[\]\(\)=>\|])/g,"\\$1")},isRTL:function(a){var t=e(document),r=e("body"),i=a&&a.hasClass("rtl")||a&&"rtl"===(a.attr("dir")||"").toLowerCase()||t.hasClass("rtl")||"rtl"===(t.attr("dir")||"").toLowerCase()||r.hasClass("rtl")||"rtl"===(r.attr("dir")||"").toLowerCase();return Boolean(i)},_calculatePosition:function(e,a,t){var r,i,o,s=e.width(),n=e.position().left,l=e.position().top,d=(e.height(),a.height());r=i=0,o=-d;var u=e.data("promptPosition")||t.promptPosition,c="",f="",v=0,p=0;switch("string"==typeof u&&-1!=u.indexOf(":")&&(c=u.substring(u.indexOf(":")+1),u=u.substring(0,u.indexOf(":")),-1!=c.indexOf(",")&&(f=c.substring(c.indexOf(",")+1),c=c.substring(0,c.indexOf(",")),p=parseInt(f),isNaN(p)&&(p=0)),v=parseInt(c),isNaN(c)&&(c=0)),u){default:case"topRight":i+=n+s-27,r+=l;break;case"topLeft":r+=l,i+=n;break;case"centerRight":r=l+4,o=0,i=n+e.outerWidth(!0)+5;break;case"centerLeft":i=n-(a.width()+2),r=l+4,o=0;break;case"bottomLeft":r=l+e.height()+5,o=0,i=n;break;case"bottomRight":i=n+s-27,r=l+e.height()+5,o=0;break;case"inline":i=0,r=0,o=0}return i+=v,r+=p,{callerTopPosition:r+"px",callerleftPosition:i+"px",marginTopSize:o+"px"}},_saveOptions:function(a,t){if(e.validationEngineLanguage)var r=e.validationEngineLanguage.allRules;else e.error("jQuery.validationEngine rules are not loaded, plz add localization files to the page");e.validationEngine.defaults.allrules=r;var i=e.extend(!0,{},e.validationEngine.defaults,t);return a.data("jqv",i),i},_getClassName:function(e){return e?e.replace(/:/g,"_").replace(/\./g,"_"):void 0},_jqSelector:function(e){return e.replace(/([;&,\.\+\*\~':"\!\^#$%@\[\]\(\)=>\|])/g,"\\$1")},_condRequired:function(e,t,r,i){var o,s;for(o=r+1;o<t.length;o++)if(s=jQuery("#"+t[o]).first(),s.length&&void 0==a._required(s,["required"],0,i,!0))return a._required(e,["required"],0,i)},_submitButtonClick:function(){var a=e(this),t=a.closest("form, .validationEngineContainer");t.data("jqv_submitButton",a.attr("id"))}};e.fn.validationEngine=function(t){var r=e(this);return r[0]?"string"==typeof t&&"_"!=t.charAt(0)&&a[t]?("showPrompt"!=t&&"hide"!=t&&"hideAll"!=t&&a.init.apply(r),a[t].apply(r,Array.prototype.slice.call(arguments,1))):"object"!=typeof t&&t?void e.error("Method "+t+" does not exist in jQuery.validationEngine"):(a.init.apply(r,arguments),a.attach.apply(r)):r},e.validationEngine={fieldIdCounter:0,defaults:{validationEventTrigger:"blur",scroll:!0,focusFirstField:!0,showPrompts:!0,validateNonVisibleFields:!1,ignoreFieldsWithClass:"ignoreMe",promptPosition:"topRight",bindMethod:"bind",inlineAjax:!1,ajaxFormValidation:!1,ajaxFormValidationURL:!1,ajaxFormValidationMethod:"get",onAjaxFormComplete:e.noop,onBeforeAjaxFormValidation:e.noop,onValidationComplete:!1,doNotShowAllErrosOnSubmit:!1,custom_error_messages:{},binded:!0,notEmpty:!1,showArrow:!0,showArrowOnRadioAndCheckbox:!1,isError:!1,maxErrorsPerField:!1,ajaxValidCache:{},autoPositionUpdate:!1,InvalidFields:[],onFieldSuccess:!1,onFieldFailure:!1,onSuccess:!1,onFailure:!1,validateAttribute:"class",addSuccessCssClassToField:"",addFailureCssClassToField:"",autoHidePrompt:!1,autoHideDelay:1e4,fadeDuration:.3,prettySelect:!1,addPromptClass:"",usePrefix:"",useSuffix:"",showOneMessage:!1}},e(function(){e.validationEngine.defaults.promptPosition=a.isRTL()?"topLeft":"topRight"})}(jQuery);





/*!
 * pickadate.js v3.5.4, 2014/09/11
 * By Amsul, http://amsul.ca
 * Hosted on http://amsul.github.io/pickadate.js
 * Licensed under MIT
 */
!function(a){"function"==typeof define&&define.amd?define("picker",["jquery"],a):"object"==typeof exports?module.exports=a(require("jquery")):this.Picker=a(jQuery)}(function(a){function b(f,g,h,k){function l(){return b._.node("div",b._.node("div",b._.node("div",b._.node("div",w.component.nodes(r.open),t.box),t.wrap),t.frame),t.holder)}function m(){u.data(g,w).addClass(t.input).val(u.data("value")?w.get("select",s.format):f.value).on("focus."+r.id+" click."+r.id,p),s.editable||u.on("keydown."+r.id,function(a){var b=a.keyCode,c=/^(8|46)$/.test(b);return 27==b?(w.close(),!1):void((32==b||c||!r.open&&w.component.key[b])&&(a.preventDefault(),a.stopPropagation(),c?w.clear().close():w.open()))}),e(f,{haspopup:!0,expanded:!1,readonly:!1,owns:f.id+"_root"+(w._hidden?" "+w._hidden.id:"")})}function n(){w.$root.on({focusin:function(a){w.$root.removeClass(t.focused),a.stopPropagation()},"mousedown click":function(b){var c=b.target;c!=w.$root.children()[0]&&(b.stopPropagation(),"mousedown"!=b.type||a(c).is(":input")||"OPTION"==c.nodeName||(b.preventDefault(),f.focus()))}}).on("click","[data-pick], [data-nav], [data-clear], [data-close]",function(){var b=a(this),c=b.data(),d=b.hasClass(t.navDisabled)||b.hasClass(t.disabled),e=document.activeElement;e=e&&(e.type||e.href)&&e,(d||e&&!a.contains(w.$root[0],e))&&f.focus(),!d&&c.nav?w.set("highlight",w.component.item.highlight,{nav:c.nav}):!d&&"pick"in c?w.set("select",c.pick).close(!0):c.clear?w.clear().close(!0):c.close&&w.close(!0)}),e(w.$root[0],"hidden",!0)}function o(){var b;s.hiddenName===!0?(b=f.name,f.name=""):(b=["string"==typeof s.hiddenPrefix?s.hiddenPrefix:"","string"==typeof s.hiddenSuffix?s.hiddenSuffix:"_submit"],b=b[0]+f.name+b[1]),w._hidden=a('<input type=hidden name="'+b+'"'+(u.data("value")||f.value?' value="'+w.get("select",s.formatSubmit)+'"':"")+">")[0],u.on("change."+r.id,function(){w._hidden.value=f.value?w.get("select",s.formatSubmit):""}).after(w._hidden)}function p(a){a.stopPropagation(),"focus"==a.type&&w.$root.addClass(t.focused),w.open()}if(!f)return b;var q=!1,r={id:f.id||"P"+Math.abs(~~(Math.random()*new Date))},s=h?a.extend(!0,{},h.defaults,k):k||{},t=a.extend({},b.klasses(),s.klass),u=a(f),v=function(){return this.start()},w=v.prototype={constructor:v,$node:u,start:function(){return r&&r.start?w:(r.methods={},r.start=!0,r.open=!1,r.type=f.type,f.autofocus=f==document.activeElement,f.readOnly=!s.editable,f.id=f.id||r.id,"text"!=f.type&&(f.type="text"),w.component=new h(w,s),w.$root=a(b._.node("div",l(),t.picker,'id="'+f.id+'_root"')),n(),s.formatSubmit&&o(),m(),s.container?a(s.container).append(w.$root):u.after(w.$root),w.on({start:w.component.onStart,render:w.component.onRender,stop:w.component.onStop,open:w.component.onOpen,close:w.component.onClose,set:w.component.onSet}).on({start:s.onStart,render:s.onRender,stop:s.onStop,open:s.onOpen,close:s.onClose,set:s.onSet}),q=c(w.$root.children()[0]),f.autofocus&&w.open(),w.trigger("start").trigger("render"))},render:function(a){return a?w.$root.html(l()):w.$root.find("."+t.box).html(w.component.nodes(r.open)),w.trigger("render")},stop:function(){return r.start?(w.close(),w._hidden&&w._hidden.parentNode.removeChild(w._hidden),w.$root.remove(),u.removeClass(t.input).removeData(g),setTimeout(function(){u.off("."+r.id)},0),f.type=r.type,f.readOnly=!1,w.trigger("stop"),r.methods={},r.start=!1,w):w},open:function(c){return r.open?w:(u.addClass(t.active),e(f,"expanded",!0),setTimeout(function(){w.$root.addClass(t.opened),e(w.$root[0],"hidden",!1)},0),c!==!1&&(r.open=!0,q&&j.css("overflow","hidden").css("padding-right","+="+d()),u.trigger("focus"),i.on("click."+r.id+" focusin."+r.id,function(a){var b=a.target;b!=f&&b!=document&&3!=a.which&&w.close(b===w.$root.children()[0])}).on("keydown."+r.id,function(c){var d=c.keyCode,e=w.component.key[d],g=c.target;27==d?w.close(!0):g!=f||!e&&13!=d?a.contains(w.$root[0],g)&&13==d&&(c.preventDefault(),g.click()):(c.preventDefault(),e?b._.trigger(w.component.key.go,w,[b._.trigger(e)]):w.$root.find("."+t.highlighted).hasClass(t.disabled)||w.set("select",w.component.item.highlight).close())})),w.trigger("open"))},close:function(a){return a&&(u.off("focus."+r.id).trigger("focus"),setTimeout(function(){u.on("focus."+r.id,p)},0)),u.removeClass(t.active),e(f,"expanded",!1),setTimeout(function(){w.$root.removeClass(t.opened+" "+t.focused),e(w.$root[0],"hidden",!0)},0),r.open?(r.open=!1,q&&j.css("overflow","").css("padding-right","-="+d()),i.off("."+r.id),w.trigger("close")):w},clear:function(a){return w.set("clear",null,a)},set:function(b,c,d){var e,f,g=a.isPlainObject(b),h=g?b:{};if(d=g&&a.isPlainObject(c)?c:d||{},b){g||(h[b]=c);for(e in h)f=h[e],e in w.component.item&&(void 0===f&&(f=null),w.component.set(e,f,d)),("select"==e||"clear"==e)&&u.val("clear"==e?"":w.get(e,s.format)).trigger("change");w.render()}return d.muted?w:w.trigger("set",h)},get:function(a,c){if(a=a||"value",null!=r[a])return r[a];if("value"==a)return f.value;if(a in w.component.item){if("string"==typeof c){var d=w.component.get(a);return d?b._.trigger(w.component.formats.toString,w.component,[c,d]):""}return w.component.get(a)}},on:function(b,c,d){var e,f,g=a.isPlainObject(b),h=g?b:{};if(b){g||(h[b]=c);for(e in h)f=h[e],d&&(e="_"+e),r.methods[e]=r.methods[e]||[],r.methods[e].push(f)}return w},off:function(){var a,b,c=arguments;for(a=0,namesCount=c.length;namesCount>a;a+=1)b=c[a],b in r.methods&&delete r.methods[b];return w},trigger:function(a,c){var d=function(a){var d=r.methods[a];d&&d.map(function(a){b._.trigger(a,w,[c])})};return d("_"+a),d(a),w}};return new v}function c(a){var b,c="position";return a.currentStyle?b=a.currentStyle[c]:window.getComputedStyle&&(b=getComputedStyle(a)[c]),"fixed"==b}function d(){if(j.height()<=h.height())return 0;var b=a('<div style="visibility:hidden;width:100px" />').appendTo("body"),c=b[0].offsetWidth;b.css("overflow","scroll");var d=a('<div style="width:100%" />').appendTo(b),e=d[0].offsetWidth;return b.remove(),c-e}function e(b,c,d){if(a.isPlainObject(c))for(var e in c)f(b,e,c[e]);else f(b,c,d)}function f(a,b,c){a.setAttribute(("role"==b?"":"aria-")+b,c)}function g(b,c){a.isPlainObject(b)||(b={attribute:c}),c="";for(var d in b){var e=("role"==d?"":"aria-")+d,f=b[d];c+=null==f?"":e+'="'+b[d]+'"'}return c}var h=a(window),i=a(document),j=a(document.documentElement);return b.klasses=function(a){return a=a||"picker",{picker:a,opened:a+"--opened",focused:a+"--focused",input:a+"__input",active:a+"__input--active",holder:a+"__holder",frame:a+"__frame",wrap:a+"__wrap",box:a+"__box"}},b._={group:function(a){for(var c,d="",e=b._.trigger(a.min,a);e<=b._.trigger(a.max,a,[e]);e+=a.i)c=b._.trigger(a.item,a,[e]),d+=b._.node(a.node,c[0],c[1],c[2]);return d},node:function(b,c,d,e){return c?(c=a.isArray(c)?c.join(""):c,d=d?' class="'+d+'"':"",e=e?" "+e:"","<"+b+d+e+">"+c+"</"+b+">"):""},lead:function(a){return(10>a?"0":"")+a},trigger:function(a,b,c){return"function"==typeof a?a.apply(b,c||[]):a},digits:function(a){return/\d/.test(a[1])?2:1},isDate:function(a){return{}.toString.call(a).indexOf("Date")>-1&&this.isInteger(a.getUTCDate())},isInteger:function(a){return{}.toString.call(a).indexOf("Number")>-1&&a%1===0},ariaAttr:g},b.extend=function(c,d){a.fn[c]=function(e,f){var g=this.data(c);return"picker"==e?g:g&&"string"==typeof e?b._.trigger(g[e],g,[f]):this.each(function(){var f=a(this);f.data(c)||new b(this,c,d,e)})},a.fn[c].defaults=d.defaults},b});



/*!
 * Date picker for pickadate.js v3.5.4
 * http://amsul.github.io/pickadate.js/date.htm
 */
!function(a){"function"==typeof define&&define.amd?define(["picker","jquery"],a):"object"==typeof exports?module.exports=a(require("./picker.js"),require("jquery")):a(Picker,jQuery)}(function(a,b){function c(a,b){var c=this,d=a.$node[0],e=d.value,f=a.$node.data("value"),g=f||e,h=f?b.formatSubmit:b.format,i=function(){return d.currentStyle?"rtl"==d.currentStyle.direction:"rtl"==getComputedStyle(a.$root[0]).direction};c.settings=b,c.$node=a.$node,c.queue={min:"measure create",max:"measure create",now:"now create",select:"parse create validate",highlight:"parse navigate create validate",view:"parse create validate viewset",disable:"deactivate",enable:"activate"},c.item={},c.item.clear=null,c.item.disable=(b.disable||[]).slice(0),c.item.enable=-function(a){return a[0]===!0?a.shift():-1}(c.item.disable),c.set("min",b.min).set("max",b.max).set("now"),g?c.set("select",g,{format:h}):c.set("select",null).set("highlight",c.item.now),c.key={40:7,38:-7,39:function(){return i()?-1:1},37:function(){return i()?1:-1},go:function(a){var b=c.item.highlight,d=new Date(Date.UTC(b.year,b.month,b.date+a));c.set("highlight",d,{interval:a}),this.render()}},a.on("render",function(){a.$root.find("."+b.klass.selectMonth).on("change",function(){var c=this.value;c&&(a.set("highlight",[a.get("view").year,c,a.get("highlight").date]),a.$root.find("."+b.klass.selectMonth).trigger("focus"))}),a.$root.find("."+b.klass.selectYear).on("change",function(){var c=this.value;c&&(a.set("highlight",[c,a.get("view").month,a.get("highlight").date]),a.$root.find("."+b.klass.selectYear).trigger("focus"))})},1).on("open",function(){var d="";c.disabled(c.get("now"))&&(d=":not(."+b.klass.buttonToday+")"),a.$root.find("button"+d+", select").attr("disabled",!1)},1).on("close",function(){a.$root.find("button, select").attr("disabled",!0)},1)}var d=7,e=6,f=a._;c.prototype.set=function(a,b,c){var d=this,e=d.item;return null===b?("clear"==a&&(a="select"),e[a]=b,d):(e["enable"==a?"disable":"flip"==a?"enable":a]=d.queue[a].split(" ").map(function(e){return b=d[e](a,b,c)}).pop(),"select"==a?d.set("highlight",e.select,c):"highlight"==a?d.set("view",e.highlight,c):a.match(/^(flip|min|max|disable|enable)$/)&&(e.select&&d.disabled(e.select)&&d.set("select",e.select,c),e.highlight&&d.disabled(e.highlight)&&d.set("highlight",e.highlight,c)),d)},c.prototype.get=function(a){return this.item[a]},c.prototype.create=function(a,c,d){var e,g=this;return c=void 0===c?a:c,c==-1/0||1/0==c?e=c:b.isPlainObject(c)&&f.isInteger(c.pick)?c=c.obj:b.isArray(c)?(c=new Date(Date.UTC(c[0],c[1],c[2])),c=f.isDate(c)?c:g.create().obj):c=f.isInteger(c)?g.normalize(new Date(c),d):f.isDate(c)?g.normalize(c,d):g.now(a,c,d),{year:e||c.getUTCFullYear(),month:e||c.getUTCMonth(),date:e||c.getUTCDate(),day:e||c.getUTCDay(),obj:e||c,pick:e||c.getTime()}},c.prototype.createRange=function(a,c){var d=this,e=function(a){return a===!0||b.isArray(a)||f.isDate(a)?d.create(a):a};return f.isInteger(a)||(a=e(a)),f.isInteger(c)||(c=e(c)),f.isInteger(a)&&b.isPlainObject(c)?a=[c.year,c.month,c.date+a]:f.isInteger(c)&&b.isPlainObject(a)&&(c=[a.year,a.month,a.date+c]),{from:e(a),to:e(c)}},c.prototype.withinRange=function(a,b){return a=this.createRange(a.from,a.to),b.pick>=a.from.pick&&b.pick<=a.to.pick},c.prototype.overlapRanges=function(a,b){var c=this;return a=c.createRange(a.from,a.to),b=c.createRange(b.from,b.to),c.withinRange(a,b.from)||c.withinRange(a,b.to)||c.withinRange(b,a.from)||c.withinRange(b,a.to)},c.prototype.now=function(a,b,c){return b=new Date,c&&c.rel&&b.setUTCDate(b.getUTCDate()+c.rel),this.normalize(b,c)},c.prototype.navigate=function(a,c,d){var e,f,g,h,i=b.isArray(c),j=b.isPlainObject(c),k=this.item.view;if(i||j){for(j?(f=c.year,g=c.month,h=c.date):(f=+c[0],g=+c[1],h=+c[2]),d&&d.nav&&k&&k.month!==g&&(f=k.year,g=k.month),e=new Date(Date.UTC(f,g+(d&&d.nav?d.nav:0),1)),f=e.getUTCFullYear(),g=e.getUTCMonth();new Date(Date.UTC(f,g,h)).getUTCMonth()!==g;)h-=1;c=[f,g,h]}return c},c.prototype.normalize=function(a){return a.setUTCHours(0,0,0,0),a},c.prototype.measure=function(a,b){var c=this;return b?"string"==typeof b?b=c.parse(a,b):f.isInteger(b)&&(b=c.now(a,b,{rel:b})):b="min"==a?-1/0:1/0,b},c.prototype.viewset=function(a,b){return this.create([b.year,b.month,1])},c.prototype.validate=function(a,c,d){var e,g,h,i,j=this,k=c,l=d&&d.interval?d.interval:1,m=-1===j.item.enable,n=j.item.min,o=j.item.max,p=m&&j.item.disable.filter(function(a){if(b.isArray(a)){var d=j.create(a).pick;d<c.pick?e=!0:d>c.pick&&(g=!0)}return f.isInteger(a)}).length;if((!d||!d.nav)&&(!m&&j.disabled(c)||m&&j.disabled(c)&&(p||e||g)||!m&&(c.pick<=n.pick||c.pick>=o.pick)))for(m&&!p&&(!g&&l>0||!e&&0>l)&&(l*=-1);j.disabled(c)&&(Math.abs(l)>1&&(c.month<k.month||c.month>k.month)&&(c=k,l=l>0?1:-1),c.pick<=n.pick?(h=!0,l=1,c=j.create([n.year,n.month,n.date+(c.pick===n.pick?0:-1)])):c.pick>=o.pick&&(i=!0,l=-1,c=j.create([o.year,o.month,o.date+(c.pick===o.pick?0:1)])),!h||!i);)c=j.create([c.year,c.month,c.date+l]);return c},c.prototype.disabled=function(a){var c=this,d=c.item.disable.filter(function(d){return f.isInteger(d)?a.day===(c.settings.firstDay?d:d-1)%7:b.isArray(d)||f.isDate(d)?a.pick===c.create(d).pick:b.isPlainObject(d)?c.withinRange(d,a):void 0});return d=d.length&&!d.filter(function(a){return b.isArray(a)&&"inverted"==a[3]||b.isPlainObject(a)&&a.inverted}).length,-1===c.item.enable?!d:d||a.pick<c.item.min.pick||a.pick>c.item.max.pick},c.prototype.parse=function(a,b,c){var d=this,e={};return b&&"string"==typeof b?(c&&c.format||(c=c||{},c.format=d.settings.format),d.formats.toArray(c.format).map(function(a){var c=d.formats[a],g=c?f.trigger(c,d,[b,e]):a.replace(/^!/,"").length;c&&(e[a]=b.substr(0,g)),b=b.substr(g)}),[e.yyyy||e.yy,+(e.mm||e.m)-1,e.dd||e.d]):b},c.prototype.formats=function(){function a(a,b,c){var d=a.match(/\w+/)[0];return c.mm||c.m||(c.m=b.indexOf(d)+1),d.length}function b(a){return a.match(/\w+/)[0].length}return{d:function(a,b){return a?f.digits(a):b.date},dd:function(a,b){return a?2:f.lead(b.date)},ddd:function(a,c){return a?b(a):this.settings.weekdaysShort[c.day]},dddd:function(a,c){return a?b(a):this.settings.weekdaysFull[c.day]},m:function(a,b){return a?f.digits(a):b.month+1},mm:function(a,b){return a?2:f.lead(b.month+1)},mmm:function(b,c){var d=this.settings.monthsShort;return b?a(b,d,c):d[c.month]},mmmm:function(b,c){var d=this.settings.monthsFull;return b?a(b,d,c):d[c.month]},yy:function(a,b){return a?2:(""+b.year).slice(2)},yyyy:function(a,b){return a?4:b.year},toArray:function(a){return a.split(/(d{1,4}|m{1,4}|y{4}|yy|!.)/g)},toString:function(a,b){var c=this;return c.formats.toArray(a).map(function(a){return f.trigger(c.formats[a],c,[0,b])||a.replace(/^!/,"")}).join("")}}}(),c.prototype.isDateExact=function(a,c){var d=this;return f.isInteger(a)&&f.isInteger(c)||"boolean"==typeof a&&"boolean"==typeof c?a===c:(f.isDate(a)||b.isArray(a))&&(f.isDate(c)||b.isArray(c))?d.create(a).pick===d.create(c).pick:b.isPlainObject(a)&&b.isPlainObject(c)?d.isDateExact(a.from,c.from)&&d.isDateExact(a.to,c.to):!1},c.prototype.isDateOverlap=function(a,c){var d=this,e=d.settings.firstDay?1:0;return f.isInteger(a)&&(f.isDate(c)||b.isArray(c))?(a=a%7+e,a===d.create(c).day+1):f.isInteger(c)&&(f.isDate(a)||b.isArray(a))?(c=c%7+e,c===d.create(a).day+1):b.isPlainObject(a)&&b.isPlainObject(c)?d.overlapRanges(a,c):!1},c.prototype.flipEnable=function(a){var b=this.item;b.enable=a||(-1==b.enable?1:-1)},c.prototype.deactivate=function(a,c){var d=this,e=d.item.disable.slice(0);return"flip"==c?d.flipEnable():c===!1?(d.flipEnable(1),e=[]):c===!0?(d.flipEnable(-1),e=[]):c.map(function(a){for(var c,g=0;g<e.length;g+=1)if(d.isDateExact(a,e[g])){c=!0;break}c||(f.isInteger(a)||f.isDate(a)||b.isArray(a)||b.isPlainObject(a)&&a.from&&a.to)&&e.push(a)}),e},c.prototype.activate=function(a,c){var d=this,e=d.item.disable,g=e.length;return"flip"==c?d.flipEnable():c===!0?(d.flipEnable(1),e=[]):c===!1?(d.flipEnable(-1),e=[]):c.map(function(a){var c,h,i,j;for(i=0;g>i;i+=1){if(h=e[i],d.isDateExact(h,a)){c=e[i]=null,j=!0;break}if(d.isDateOverlap(h,a)){b.isPlainObject(a)?(a.inverted=!0,c=a):b.isArray(a)?(c=a,c[3]||c.push("inverted")):f.isDate(a)&&(c=[a.getUTCFullYear(),a.getUTCMonth(),a.getUTCDate(),"inverted"]);break}}if(c)for(i=0;g>i;i+=1)if(d.isDateExact(e[i],a)){e[i]=null;break}if(j)for(i=0;g>i;i+=1)if(d.isDateOverlap(e[i],a)){e[i]=null;break}c&&e.push(c)}),e.filter(function(a){return null!=a})},c.prototype.nodes=function(a){var b=this,c=b.settings,g=b.item,h=g.now,i=g.select,j=g.highlight,k=g.view,l=g.disable,m=g.min,n=g.max,o=function(a,b){return c.firstDay&&(a.push(a.shift()),b.push(b.shift())),f.node("thead",f.node("tr",f.group({min:0,max:d-1,i:1,node:"th",item:function(d){return[a[d],c.klass.weekdays,'scope=col title="'+b[d]+'"']}})))}((c.showWeekdaysFull?c.weekdaysFull:c.weekdaysShort).slice(0),c.weekdaysFull.slice(0)),p=function(a){return f.node("div"," ",c.klass["nav"+(a?"Next":"Prev")]+(a&&k.year>=n.year&&k.month>=n.month||!a&&k.year<=m.year&&k.month<=m.month?" "+c.klass.navDisabled:""),"data-nav="+(a||-1)+" "+f.ariaAttr({role:"button",controls:b.$node[0].id+"_table"})+' title="'+(a?c.labelMonthNext:c.labelMonthPrev)+'"')},q=function(){var d=c.showMonthsShort?c.monthsShort:c.monthsFull;return c.selectMonths?f.node("select",f.group({min:0,max:11,i:1,node:"option",item:function(a){return[d[a],0,"value="+a+(k.month==a?" selected":"")+(k.year==m.year&&a<m.month||k.year==n.year&&a>n.month?" disabled":"")]}}),c.klass.selectMonth,(a?"":"disabled")+" "+f.ariaAttr({controls:b.$node[0].id+"_table"})+' title="'+c.labelMonthSelect+'"'):f.node("div",d[k.month],c.klass.month)},r=function(){var d=k.year,e=c.selectYears===!0?5:~~(c.selectYears/2);if(e){var g=m.year,h=n.year,i=d-e,j=d+e;if(g>i&&(j+=g-i,i=g),j>h){var l=i-g,o=j-h;i-=l>o?o:l,j=h}return f.node("select",f.group({min:i,max:j,i:1,node:"option",item:function(a){return[a,0,"value="+a+(d==a?" selected":"")]}}),c.klass.selectYear,(a?"":"disabled")+" "+f.ariaAttr({controls:b.$node[0].id+"_table"})+' title="'+c.labelYearSelect+'"')}return f.node("div",d,c.klass.year)};return f.node("div",(c.selectYears?r()+q():q()+r())+p()+p(1),c.klass.header)+f.node("table",o+f.node("tbody",f.group({min:0,max:e-1,i:1,node:"tr",item:function(a){var e=c.firstDay&&0===b.create([k.year,k.month,1]).day?-7:0;return[f.group({min:d*a-k.day+e+1,max:function(){return this.min+d-1},i:1,node:"td",item:function(a){a=b.create([k.year,k.month,a+(c.firstDay?1:0)]);var d=i&&i.pick==a.pick,e=j&&j.pick==a.pick,g=l&&b.disabled(a)||a.pick<m.pick||a.pick>n.pick;return[f.node("div",a.date,function(b){return b.push(k.month==a.month?c.klass.infocus:c.klass.outfocus),h.pick==a.pick&&b.push(c.klass.now),d&&b.push(c.klass.selected),e&&b.push(c.klass.highlighted),g&&b.push(c.klass.disabled),b.join(" ")}([c.klass.day]),"data-pick="+a.pick+" "+f.ariaAttr({role:"gridcell",selected:d&&b.$node.val()===f.trigger(b.formats.toString,b,[c.format,a])?!0:null,activedescendant:e?!0:null,disabled:g?!0:null})),"",f.ariaAttr({role:"presentation"})]}})]}})),c.klass.table,'id="'+b.$node[0].id+'_table" '+f.ariaAttr({role:"grid",controls:b.$node[0].id,readonly:!0}))+f.node("div",f.node("button",c.today,c.klass.buttonToday,"type=button data-pick="+h.pick+(a&&!b.disabled(h)?"":" disabled")+" "+f.ariaAttr({controls:b.$node[0].id}))+f.node("button",c.clear,c.klass.buttonClear,"type=button data-clear=1"+(a?"":" disabled")+" "+f.ariaAttr({controls:b.$node[0].id}))+f.node("button",c.close,c.klass.buttonClose,"type=button data-close=true "+(a?"":" disabled")+" "+f.ariaAttr({controls:b.$node[0].id})),c.klass.footer)},c.defaults=function(a){return{labelMonthNext:"Next month",labelMonthPrev:"Previous month",labelMonthSelect:"Select a month",labelYearSelect:"Select a year",monthsFull:["January","February","March","April","May","June","July","August","September","October","November","December"],monthsShort:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],weekdaysFull:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],weekdaysShort:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],today:"Today",clear:"Clear",close:"Close",format:"d mmmm, yyyy",klass:{table:a+"table",header:a+"header",navPrev:a+"nav--prev",navNext:a+"nav--next",navDisabled:a+"nav--disabled",month:a+"month",year:a+"year",selectMonth:a+"select--month",selectYear:a+"select--year",weekdays:a+"weekday",day:a+"day",disabled:a+"day--disabled",selected:a+"day--selected",highlighted:a+"day--highlighted",now:a+"day--today",infocus:a+"day--infocus",outfocus:a+"day--outfocus",footer:a+"footer",buttonClear:a+"button--clear",buttonToday:a+"button--today",buttonClose:a+"button--close"}}}(a.klasses().picker+"__"),a.extend("pickadate",c)});

/*!
 * Time picker for pickadate.js v3.5.4
 * http://amsul.github.io/pickadate.js/time.htm
 */
!function(a){"function"==typeof define&&define.amd?define(["picker","jquery"],a):"object"==typeof exports?module.exports=a(require("./picker.js"),require("jquery")):a(Picker,jQuery)}(function(a,b){function c(a,b){var c=this,d=a.$node[0].value,e=a.$node.data("value"),f=e||d,g=e?b.formatSubmit:b.format;c.settings=b,c.$node=a.$node,c.queue={interval:"i",min:"measure create",max:"measure create",now:"now create",select:"parse create validate",highlight:"parse create validate",view:"parse create validate",disable:"deactivate",enable:"activate"},c.item={},c.item.clear=null,c.item.interval=b.interval||30,c.item.disable=(b.disable||[]).slice(0),c.item.enable=-function(a){return a[0]===!0?a.shift():-1}(c.item.disable),c.set("min",b.min).set("max",b.max).set("now"),f?c.set("select",f,{format:g,fromValue:!!d}):c.set("select",null).set("highlight",c.item.now),c.key={40:1,38:-1,39:1,37:-1,go:function(a){c.set("highlight",c.item.highlight.pick+a*c.item.interval,{interval:a*c.item.interval}),this.render()}},a.on("render",function(){var c=a.$root.children(),d=c.find("."+b.klass.viewset),e=function(a){return["webkit","moz","ms","o",""].map(function(b){return(b?"-"+b+"-":"")+a})},f=function(a,b){e("transform").map(function(c){a.css(c,b)}),e("transition").map(function(c){a.css(c,b)})};d.length&&(f(c,"none"),c[0].scrollTop=~~d.position().top-2*d[0].clientHeight,f(c,""))},1).on("open",function(){a.$root.find("button").attr("disabled",!1)},1).on("close",function(){a.$root.find("button").attr("disabled",!0)},1)}var d=24,e=60,f=12,g=d*e,h=a._;c.prototype.set=function(a,b,c){var d=this,e=d.item;return null===b?("clear"==a&&(a="select"),e[a]=b,d):(e["enable"==a?"disable":"flip"==a?"enable":a]=d.queue[a].split(" ").map(function(e){return b=d[e](a,b,c)}).pop(),"select"==a?d.set("highlight",e.select,c):"highlight"==a?d.set("view",e.highlight,c):"interval"==a?d.set("min",e.min,c).set("max",e.max,c):a.match(/^(flip|min|max|disable|enable)$/)&&("min"==a&&d.set("max",e.max,c),e.select&&d.disabled(e.select)&&d.set("select",e.select,c),e.highlight&&d.disabled(e.highlight)&&d.set("highlight",e.highlight,c)),d)},c.prototype.get=function(a){return this.item[a]},c.prototype.create=function(a,c,f){var i=this;return c=void 0===c?a:c,h.isDate(c)&&(c=[c.getHours(),c.getMinutes()]),b.isPlainObject(c)&&h.isInteger(c.pick)?c=c.pick:b.isArray(c)?c=+c[0]*e+ +c[1]:h.isInteger(c)||(c=i.now(a,c,f)),"max"==a&&c<i.item.min.pick&&(c+=g),"min"!=a&&"max"!=a&&(c-i.item.min.pick)%i.item.interval!==0&&(c+=i.item.interval),c=i.normalize(a,c,f),{hour:~~(d+c/e)%d,mins:(e+c%e)%e,time:(g+c)%g,pick:c}},c.prototype.createRange=function(a,c){var d=this,e=function(a){return a===!0||b.isArray(a)||h.isDate(a)?d.create(a):a};return h.isInteger(a)||(a=e(a)),h.isInteger(c)||(c=e(c)),h.isInteger(a)&&b.isPlainObject(c)?a=[c.hour,c.mins+a*d.settings.interval]:h.isInteger(c)&&b.isPlainObject(a)&&(c=[a.hour,a.mins+c*d.settings.interval]),{from:e(a),to:e(c)}},c.prototype.withinRange=function(a,b){return a=this.createRange(a.from,a.to),b.pick>=a.from.pick&&b.pick<=a.to.pick},c.prototype.overlapRanges=function(a,b){var c=this;return a=c.createRange(a.from,a.to),b=c.createRange(b.from,b.to),c.withinRange(a,b.from)||c.withinRange(a,b.to)||c.withinRange(b,a.from)||c.withinRange(b,a.to)},c.prototype.now=function(a,b){var c,d=this.item.interval,f=new Date,g=f.getHours()*e+f.getMinutes(),i=h.isInteger(b);return g-=g%d,c=0>b&&-d>=d*b+g,g+="min"==a&&c?0:d,i&&(g+=d*(c&&"max"!=a?b+1:b)),g},c.prototype.normalize=function(a,b){var c=this.item.interval,d=this.item.min&&this.item.min.pick||0;return b-="min"==a?0:(b-d)%c},c.prototype.measure=function(a,c,f){var g=this;return c||(c="min"==a?[0,0]:[d-1,e-1]),"string"==typeof c?c=g.parse(a,c):c===!0||h.isInteger(c)?c=g.now(a,c,f):b.isPlainObject(c)&&h.isInteger(c.pick)&&(c=g.normalize(a,c.pick,f)),c},c.prototype.validate=function(a,b,c){var d=this,e=c&&c.interval?c.interval:d.item.interval;return d.disabled(b)&&(b=d.shift(b,e)),b=d.scope(b),d.disabled(b)&&(b=d.shift(b,-1*e)),b},c.prototype.disabled=function(a){var c=this,d=c.item.disable.filter(function(d){return h.isInteger(d)?a.hour==d:b.isArray(d)||h.isDate(d)?a.pick==c.create(d).pick:b.isPlainObject(d)?c.withinRange(d,a):void 0});return d=d.length&&!d.filter(function(a){return b.isArray(a)&&"inverted"==a[2]||b.isPlainObject(a)&&a.inverted}).length,-1===c.item.enable?!d:d||a.pick<c.item.min.pick||a.pick>c.item.max.pick},c.prototype.shift=function(a,b){var c=this,d=c.item.min.pick,e=c.item.max.pick;for(b=b||c.item.interval;c.disabled(a)&&(a=c.create(a.pick+=b),!(a.pick<=d||a.pick>=e)););return a},c.prototype.scope=function(a){var b=this.item.min.pick,c=this.item.max.pick;return this.create(a.pick>c?c:a.pick<b?b:a)},c.prototype.parse=function(a,b,c){var d,f,g,i,j,k=this,l={};if(!b||"string"!=typeof b)return b;c&&c.format||(c=c||{},c.format=k.settings.format),k.formats.toArray(c.format).map(function(a){var c,d=k.formats[a],e=d?h.trigger(d,k,[b,l]):a.replace(/^!/,"").length;d&&(c=b.substr(0,e),l[a]=c.match(/^\d+$/)?+c:c),b=b.substr(e)});for(i in l)j=l[i],h.isInteger(j)?i.match(/^(h|hh)$/i)?(d=j,("h"==i||"hh"==i)&&(d%=12)):"i"==i&&(f=j):i.match(/^a$/i)&&j.match(/^p/i)&&("h"in l||"hh"in l)&&(g=!0);return(g?d+12:d)*e+f},c.prototype.formats={h:function(a,b){return a?h.digits(a):b.hour%f||f},hh:function(a,b){return a?2:h.lead(b.hour%f||f)},H:function(a,b){return a?h.digits(a):""+b.hour%24},HH:function(a,b){return a?h.digits(a):h.lead(b.hour%24)},i:function(a,b){return a?2:h.lead(b.mins)},a:function(a,b){return a?4:g/2>b.time%g?"a.m.":"p.m."},A:function(a,b){return a?2:g/2>b.time%g?"AM":"PM"},toArray:function(a){return a.split(/(h{1,2}|H{1,2}|i|a|A|!.)/g)},toString:function(a,b){var c=this;return c.formats.toArray(a).map(function(a){return h.trigger(c.formats[a],c,[0,b])||a.replace(/^!/,"")}).join("")}},c.prototype.isTimeExact=function(a,c){var d=this;return h.isInteger(a)&&h.isInteger(c)||"boolean"==typeof a&&"boolean"==typeof c?a===c:(h.isDate(a)||b.isArray(a))&&(h.isDate(c)||b.isArray(c))?d.create(a).pick===d.create(c).pick:b.isPlainObject(a)&&b.isPlainObject(c)?d.isTimeExact(a.from,c.from)&&d.isTimeExact(a.to,c.to):!1},c.prototype.isTimeOverlap=function(a,c){var d=this;return h.isInteger(a)&&(h.isDate(c)||b.isArray(c))?a===d.create(c).hour:h.isInteger(c)&&(h.isDate(a)||b.isArray(a))?c===d.create(a).hour:b.isPlainObject(a)&&b.isPlainObject(c)?d.overlapRanges(a,c):!1},c.prototype.flipEnable=function(a){var b=this.item;b.enable=a||(-1==b.enable?1:-1)},c.prototype.deactivate=function(a,c){var d=this,e=d.item.disable.slice(0);return"flip"==c?d.flipEnable():c===!1?(d.flipEnable(1),e=[]):c===!0?(d.flipEnable(-1),e=[]):c.map(function(a){for(var c,f=0;f<e.length;f+=1)if(d.isTimeExact(a,e[f])){c=!0;break}c||(h.isInteger(a)||h.isDate(a)||b.isArray(a)||b.isPlainObject(a)&&a.from&&a.to)&&e.push(a)}),e},c.prototype.activate=function(a,c){var d=this,e=d.item.disable,f=e.length;return"flip"==c?d.flipEnable():c===!0?(d.flipEnable(1),e=[]):c===!1?(d.flipEnable(-1),e=[]):c.map(function(a){var c,g,i,j;for(i=0;f>i;i+=1){if(g=e[i],d.isTimeExact(g,a)){c=e[i]=null,j=!0;break}if(d.isTimeOverlap(g,a)){b.isPlainObject(a)?(a.inverted=!0,c=a):b.isArray(a)?(c=a,c[2]||c.push("inverted")):h.isDate(a)&&(c=[a.getFullYear(),a.getMonth(),a.getDate(),"inverted"]);break}}if(c)for(i=0;f>i;i+=1)if(d.isTimeExact(e[i],a)){e[i]=null;break}if(j)for(i=0;f>i;i+=1)if(d.isTimeOverlap(e[i],a)){e[i]=null;break}c&&e.push(c)}),e.filter(function(a){return null!=a})},c.prototype.i=function(a,b){return h.isInteger(b)&&b>0?b:this.item.interval},c.prototype.nodes=function(a){var b=this,c=b.settings,d=b.item.select,e=b.item.highlight,f=b.item.view,g=b.item.disable;return h.node("ul",h.group({min:b.item.min.pick,max:b.item.max.pick,i:b.item.interval,node:"li",item:function(a){a=b.create(a);var i=a.pick,j=d&&d.pick==i,k=e&&e.pick==i,l=g&&b.disabled(a);return[h.trigger(b.formats.toString,b,[h.trigger(c.formatLabel,b,[a])||c.format,a]),function(a){return j&&a.push(c.klass.selected),k&&a.push(c.klass.highlighted),f&&f.pick==i&&a.push(c.klass.viewset),l&&a.push(c.klass.disabled),a.join(" ")}([c.klass.listItem]),"data-pick="+a.pick+" "+h.ariaAttr({role:"option",selected:j&&b.$node.val()===h.trigger(b.formats.toString,b,[c.format,a])?!0:null,activedescendant:k?!0:null,disabled:l?!0:null})]}})+h.node("li",h.node("button",c.clear,c.klass.buttonClear,"type=button data-clear=1"+(a?"":" disabled")+" "+h.ariaAttr({controls:b.$node[0].id})),"",h.ariaAttr({role:"presentation"})),c.klass.list,h.ariaAttr({role:"listbox",controls:b.$node[0].id}))},c.defaults=function(a){return{clear:"Clear",format:"h:i A",interval:30,klass:{picker:a+" "+a+"--time",holder:a+"__holder",list:a+"__list",listItem:a+"__list-item",disabled:a+"__list-item--disabled",selected:a+"__list-item--selected",highlighted:a+"__list-item--highlighted",viewset:a+"__list-item--viewset",now:a+"__list-item--now",buttonClear:a+"__button--clear"}}}(a.klasses().picker),a.extend("pickatime",c)});